diff -ruN vdr-1.7.16/PLUGINS/src/osddemo/osddemo.c vdr-1.7.17/PLUGINS/src/osddemo/osddemo.c
--- vdr-1.7.16/PLUGINS/src/osddemo/osddemo.c	2008-04-13 14:59:57.000000000 +0200
+++ vdr-1.7.17/PLUGINS/src/osddemo/osddemo.c	2011-02-26 13:08:13.000000000 +0100
@@ -3,12 +3,13 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: osddemo.c 2.1 2008/04/13 12:59:57 kls Exp $
+ * $Id: osddemo.c 2.3 2011/02/26 12:08:13 kls Exp $
  */
 
+#include <vdr/osd.h>
 #include <vdr/plugin.h>
 
-static const char *VERSION        = "0.1.3";
+static const char *VERSION        = "0.2.0";
 static const char *DESCRIPTION    = "Demo of arbitrary OSD setup";
 static const char *MAINMENUENTRY  = "Osd Demo";
 
@@ -22,7 +23,7 @@
   tColor color;
 public:
   cLineGame(void);
-  ~cLineGame();
+  virtual ~cLineGame();
   virtual void Show(void);
   virtual eOSState ProcessKey(eKeys Key);
   };
@@ -73,6 +74,366 @@
   return state;
 }
 
+// --- cTrueColorDemo --------------------------------------------------------
+
+class cTrueColorDemo : public cOsdObject, public cThread {
+private:
+  cOsd *osd;
+  cPoint cursor;
+  cRect cursorLimits;
+  bool clockwise;
+  cPixmap *destroyablePixmap;
+  cPixmap *toggleablePixmap;
+  virtual void Action(void);
+  cPixmap *CreateTextPixmap(const char *s, int Line, int Layer, tColor ColorFg, tColor ColorBg, const cFont *Font = NULL);
+public:
+  cTrueColorDemo(void);
+  virtual ~cTrueColorDemo();
+  virtual void Show(void);
+  virtual eOSState ProcessKey(eKeys Key);
+  };
+
+cTrueColorDemo::cTrueColorDemo(void)
+{
+  osd = NULL;
+  clockwise = true;
+  destroyablePixmap = NULL;
+  toggleablePixmap = NULL;
+}
+
+cTrueColorDemo::~cTrueColorDemo()
+{
+  delete osd;
+}
+
+cPixmap *cTrueColorDemo::CreateTextPixmap(const char *s, int Line, int Layer, tColor ColorFg, tColor ColorBg, const cFont *Font)
+{
+  if (!Font)
+     Font = cFont::GetFont(fontOsd);
+  const int h = Font->Height(s);
+  int w = Font->Width(s);
+  cPixmap *Pixmap = osd->CreatePixmap(Layer, cRect((osd->Width() - w) / 2, Line, w, h));
+  if (Pixmap) {
+     Pixmap->Clear();
+     Pixmap->SetAlpha(0);
+     Pixmap->DrawText(cPoint(0, 0), s, ColorFg, ColorBg, Font);
+     }
+  return Pixmap;
+}
+
+void cTrueColorDemo::Action(void)
+{
+  cPixmap *FadeInPixmap = NULL;
+  cPixmap *FadeOutPixmap = NULL;
+  cPixmap *MovePixmap = NULL;
+  cPixmap *NextPixmap = NULL;
+  cPixmap *TilePixmap = NULL;
+  cPixmap *ScrollPixmap = NULL;
+  cPixmap *AnimPixmap = NULL;
+  int FrameTime = 40; // ms
+  int FadeTime = 1000; // ms
+  int MoveTime = 4000; // ms
+  int TileTime = 6000; // ms
+  int ScrollWaitTime = 1000; // ms
+  int ScrollLineTime = 200; // ms
+  int ScrollTotalTime = 8000; // ms
+  uint64_t Start = 0;
+  uint64_t ScrollStartTime = 0;
+  int ScrollLineNumber = 0;
+  cPoint MoveStart, MoveEnd;
+  cPoint TileStart, TileEnd;
+  cPoint ScrollStart, ScrollEnd;
+  int Line = osd->Height() / 20;
+  int StartLine = Line;
+  cPoint OldCursor;
+  int State = 0;
+  while (Running()) {
+        cPixmap::Lock();
+        bool Animated = false;
+        uint64_t Now = cTimeMs::Now();
+        if (FadeInPixmap) {
+           double t = min(double(Now - Start) / FadeTime, 1.0);
+           int Alpha = t * ALPHA_OPAQUE;
+           FadeInPixmap->SetAlpha(Alpha);
+           if (t >= 1)
+              FadeInPixmap = NULL;
+           Animated = true;
+           }
+        if (FadeOutPixmap) {
+           double t = min(double(Now - Start) / FadeTime, 1.0);
+           int Alpha = ALPHA_OPAQUE - t * ALPHA_OPAQUE;
+           FadeOutPixmap->SetAlpha(Alpha);
+           if (t >= 1)
+              FadeOutPixmap = NULL;
+           Animated = true;
+           }
+        if (MovePixmap) {
+           double t = min(double(Now - Start) / MoveTime, 1.0);
+           int x = MoveStart.X() + t * (MoveEnd.X() - MoveStart.X());
+           int y = MoveStart.Y() + t * (MoveEnd.Y() - MoveStart.Y());
+           cRect r = MovePixmap->ViewPort();
+           r.SetPoint(x, y);
+           MovePixmap->SetViewPort(r);
+           if (t >= 1)
+              MovePixmap = NULL;
+           Animated = true;
+           }
+        if (TilePixmap) {
+           double t = min(double(Now - Start) / TileTime, 1.0);
+           int x = TileStart.X() + t * (TileEnd.X() - TileStart.X());
+           int y = TileStart.Y() + t * (TileEnd.Y() - TileStart.Y());
+           TilePixmap->SetDrawPortPoint(cPoint(x, y));
+           if (t >= 1) {
+              destroyablePixmap = TilePixmap;
+              TilePixmap = NULL;
+              }
+           Animated = true;
+           }
+        if (ScrollPixmap) {
+           if (int(Now - Start) > ScrollWaitTime) {
+              if (ScrollStartTime) {
+                 double t = min(double(Now - ScrollStartTime) / ScrollLineTime, 1.0);
+                 int x = ScrollStart.X() + t * (ScrollEnd.X() - ScrollStart.X());
+                 int y = ScrollStart.Y() + t * (ScrollEnd.Y() - ScrollStart.Y());
+                 ScrollPixmap->SetDrawPortPoint(cPoint(x, y));
+                 if (t >= 1) {
+                    if (int(Now - Start) < ScrollTotalTime) {
+                       cRect r = ScrollPixmap->DrawPort();
+                       r.SetPoint(-r.X(), -r.Y());
+                       ScrollPixmap->Pan(cPoint(0, 0), r);
+                       const cFont *Font = cFont::GetFont(fontOsd);
+                       cString s = cString::sprintf("Line %d", ++ScrollLineNumber);
+                       ScrollPixmap->DrawRectangle(cRect(0, ScrollPixmap->ViewPort().Height(), ScrollPixmap->DrawPort().Width(), ScrollPixmap->DrawPort().Height()), clrTransparent);
+                       ScrollPixmap->DrawText(cPoint(0, ScrollPixmap->ViewPort().Height()), s, clrYellow, clrTransparent, Font);
+                       ScrollStartTime = Now;
+                       }
+                    else {
+                       FadeOutPixmap = ScrollPixmap;
+                       ScrollPixmap = NULL;
+                       Start = cTimeMs::Now();
+                       }
+                    }
+                 }
+              else
+                 ScrollStartTime = Now;
+              }
+           Animated = true;
+           }
+        if (AnimPixmap) {
+           int d = AnimPixmap->ViewPort().Height();
+           if (clockwise)
+              d = -d;
+           cPoint p = AnimPixmap->DrawPort().Point().Shifted(0, d);
+           if (clockwise && p.Y() <= -AnimPixmap->DrawPort().Height())
+              p.SetY(0);
+           else if (!clockwise && p.Y() > 0)
+              p.SetY(-(AnimPixmap->DrawPort().Height() - AnimPixmap->ViewPort().Height()));
+           AnimPixmap->SetDrawPortPoint(p);
+           }
+        if (!Animated) {
+           switch (State) {
+             case 0: {
+                       if (cFont *Font = cFont::CreateFont(DefaultFontOsd, osd->Height() / 10)) {
+                          FadeInPixmap = CreateTextPixmap("VDR", Line, 1, clrYellow, clrTransparent, Font);
+                          if (FadeInPixmap)
+                             Line += FadeInPixmap->DrawPort().Height();
+                          delete Font;
+                          Start = cTimeMs::Now();
+                          }
+                       State++;
+                     }
+                     break;
+             case 1: { 
+                       FadeInPixmap = CreateTextPixmap("Video Disk Recorder", Line, 3, clrYellow, clrTransparent);
+                       if (FadeInPixmap)
+                          Line += FadeInPixmap->DrawPort().Height();
+                       Start = cTimeMs::Now();
+                       State++;
+                     }
+                     break;
+             case 2: {
+                       FadeInPixmap = CreateTextPixmap("True Color OSD Demo", Line, 1, clrYellow, clrTransparent);
+                       if (FadeInPixmap)
+                          Line += FadeInPixmap->DrawPort().Height();
+                       Start = cTimeMs::Now();
+                       State++;
+                     }
+                     break;
+             case 3: {
+                       if (cFont *Font = cFont::CreateFont(DefaultFontOsd, osd->Height() / 10)) {
+                          NextPixmap = CreateTextPixmap("Millions of colors", Line, 1, clrYellow, clrTransparent, Font);
+                          if (NextPixmap) {
+                             FadeInPixmap = NextPixmap;
+                             }
+                          Start = cTimeMs::Now();
+                          StartLine = Line;
+                          Line += NextPixmap->DrawPort().Height();
+                          }
+                       State++;
+                     }
+                     break;
+             case 4: {
+                       Line += osd->Height() / 10;
+                       int w = osd->Width() / 2;
+                       int h = osd->Height() - Line - osd->Height() / 10;
+                       cImage Image(cSize(w, h));
+                       for (int y = 0; y < h; y++) {
+                           for (int x = 0; x < w; x++)
+                               Image.SetPixel(cPoint(x, y), HsvToColor(360 * double(x) / w, 1 - double(y) / h, 1) | 0xDF000000);
+                           }
+                       if (cPixmap *Pixmap = osd->CreatePixmap(2, cRect((osd->Width() - w) / 2, Line, w, h))) {
+                          Pixmap->DrawImage(cPoint(0, 0), Image);
+                          toggleablePixmap = Pixmap;
+                          }
+                       State++;
+                     }
+                     break;
+             case 5: {
+                       if (NextPixmap) {
+                          MovePixmap = NextPixmap;
+                          MoveStart = MovePixmap->ViewPort().Point();
+                          MoveEnd.Set(osd->Width() - MovePixmap->ViewPort().Width(), osd->Height() - MovePixmap->ViewPort().Height());
+                          Start = cTimeMs::Now();
+                          }
+                       State++;
+                     }
+                     break;
+             case 6: {
+                       TilePixmap = CreateTextPixmap("Tiled Pixmaps", StartLine, 1, clrRed, clrWhite);
+                       if (TilePixmap) {
+                          TilePixmap->SetViewPort(TilePixmap->ViewPort().Grown(TilePixmap->DrawPort().Width(), TilePixmap->DrawPort().Height()));
+                          TilePixmap->SetAlpha(200);
+                          TilePixmap->SetTile(true);
+                          TileStart = TilePixmap->DrawPort().Point();
+                          TileEnd = TileStart.Shifted(TilePixmap->ViewPort().Width(), TilePixmap->ViewPort().Height());
+                          MovePixmap = TilePixmap;
+                          MoveStart = MovePixmap->ViewPort().Point();
+                          MoveEnd.Set(10, osd->Height() - MovePixmap->ViewPort().Height() - 10);
+                          Start = cTimeMs::Now();
+                          }
+                       State++;
+                     }
+                     break;
+             case 7: {
+                       const cFont *Font = cFont::GetFont(fontOsd);
+                       const char *Text = "Scrolling Pixmaps";
+                       int w = Font->Width(Text);
+                       int h = Font->Height();
+                       if (cPixmap *Pixmap = osd->CreatePixmap(2, cRect((osd->Width() - w) / 2, StartLine, w, 2 * h), cRect(0, 0, w, 3 * h))) {
+                          Pixmap->Clear();
+                          Pixmap->DrawText(cPoint(0, 0), Text, clrYellow, clrTransparent, Font);
+                          cString s = cString::sprintf("Line %d", ++ScrollLineNumber);
+                          Pixmap->DrawText(cPoint(0, Pixmap->ViewPort().Height()), s, clrYellow, clrTransparent, Font);
+                          ScrollPixmap = Pixmap;
+                          ScrollStart.Set(0, 0);
+                          ScrollEnd.Set(0, -h);
+                          Start = cTimeMs::Now();
+                          }
+                       State++;
+                     }
+                     break;
+             case 8: {
+                       const cFont *Font = cFont::GetFont(fontSml);
+                       const char *Text = "Animation";
+                       const int Size = Font->Width(Text) + 10;
+                       const int NumDots = 12;
+                       const int AnimFrames = NumDots;
+                       // Temporarily using pixmap layer 0 to have the text alpha blended:
+                       AnimPixmap = osd->CreatePixmap(0, cRect((osd->Width() - Size) / 2, StartLine, Size, Size), cRect(0, 0, Size, Size * AnimFrames));
+                       if (AnimPixmap) {
+                          AnimPixmap->SetAlpha(0);
+                          AnimPixmap->Clear();
+                          const int Diameter = Size / 5;
+                          int xc = Size / 2 - Diameter / 2;
+                          for (int Frame = 0; Frame < AnimFrames; Frame++) {
+                              AnimPixmap->DrawEllipse(cRect(0, Frame * Size, Size, Size), 0xDDFFFFFF);
+                              int yc = Frame * Size + Size / 2 - Diameter / 2;
+                              int Color = 0xFF;
+                              int Delta = Color / NumDots / 3;
+                              for (int a = 0; a < NumDots; a++) {
+                                  double t = 2 * M_PI * (Frame + a) / NumDots;
+                                  int x = xc + ((Size - Diameter) / 2 - 5) * cos(t);
+                                  int y = yc + ((Size - Diameter) / 2 - 5) * sin(t);
+                                  AnimPixmap->DrawEllipse(cRect(x, y, Diameter, Diameter), ArgbToColor(0xFF, Color, Color, Color));
+                                  Color -= Delta;
+                                  }
+                              AnimPixmap->DrawText(cPoint(0, Frame * Size), Text, clrBlack, clrTransparent, cFont::GetFont(fontSml), Size, Size, taCenter);
+                              }
+                          AnimPixmap->SetLayer(3); // now setting the actual pixmap layer
+                          FadeInPixmap = AnimPixmap;
+                          LOCK_THREAD;
+                          OldCursor = cursor = AnimPixmap->ViewPort().Point();
+                          cursorLimits.Set(0, 0, osd->Width(), osd->Height());
+                          cursorLimits.SetRight(cursorLimits.Right() - Size);
+                          cursorLimits.SetBottom(cursorLimits.Bottom() - Size);
+                          cursorLimits.Grow(-10, -10);
+                          Start = cTimeMs::Now();
+                          }
+                       State++;
+                     }
+                     break;
+             case 9: {
+                       LOCK_THREAD;
+                       if (cursor != OldCursor) {
+                          MovePixmap = AnimPixmap;
+                          MoveStart = MovePixmap->ViewPort().Point();
+                          MoveEnd = OldCursor = cursor;
+                          MoveTime = 500;
+                          Start = cTimeMs::Now();
+                          }
+                     }
+                     break;
+             }
+           }
+        osd->Flush();
+        cPixmap::Unlock();
+        int Delta = cTimeMs::Now() - Now;
+        if (Delta < FrameTime)
+           cCondWait::SleepMs(FrameTime - Delta);
+        }
+}
+
+void cTrueColorDemo::Show(void)
+{
+  osd = cOsdProvider::NewOsd(cOsd::OsdLeft(), cOsd::OsdTop(), 50);
+  if (osd) {
+     tArea Area = { 0, 0, cOsd::OsdWidth() - 1, cOsd::OsdHeight() - 1,  32 };
+     if (osd->SetAreas(&Area, 1) == oeOk) {
+        osd->DrawRectangle(0, 0, osd->Width() -1 , osd->Height() - 1, clrGray50);
+        osd->Flush();
+        Start();
+        }
+     }
+}
+
+eOSState cTrueColorDemo::ProcessKey(eKeys Key)
+{
+  eOSState state = cOsdObject::ProcessKey(Key);
+  if (state == osUnknown) {
+     LOCK_PIXMAPS;
+     LOCK_THREAD;
+     const int d = 80;
+     switch (Key & ~k_Repeat) {
+       case kUp:     cursor.SetY(max(cursorLimits.Top(),    cursor.Y() - d)); clockwise = false; break;
+       case kDown:   cursor.SetY(min(cursorLimits.Bottom(), cursor.Y() + d)); clockwise = true; break;
+       case kLeft:   cursor.SetX(max(cursorLimits.Left(),   cursor.X() - d)); clockwise = false; break;
+       case kRight:  cursor.SetX(min(cursorLimits.Right(),  cursor.X() + d)); clockwise = true; break;
+       case kRed:    if (destroyablePixmap) {
+                        osd->DestroyPixmap(destroyablePixmap);
+                        destroyablePixmap = NULL;
+                        }
+                     break;
+       case kGreen:  if (toggleablePixmap)
+                        toggleablePixmap->SetLayer(-toggleablePixmap->Layer());
+                     break;
+       case kOk:     return osEnd;
+       default: return state;
+       }
+     state = osContinue;
+     }
+  return state;
+}
+
 // --- cPluginOsddemo --------------------------------------------------------
 
 class cPluginOsddemo : public cPlugin {
@@ -131,6 +492,8 @@
 cOsdObject *cPluginOsddemo::MainMenuAction(void)
 {
   // Perform the action when selected from the main VDR menu.
+  if (cOsdProvider::SupportsTrueColor())
+     return new cTrueColorDemo;
   return new cLineGame;
 }
 
diff -ruN vdr-1.7.16/PLUGINS/src/pictures/HISTORY vdr-1.7.17/PLUGINS/src/pictures/HISTORY
--- vdr-1.7.16/PLUGINS/src/pictures/HISTORY	2010-02-28 13:49:50.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/pictures/HISTORY	2011-02-20 17:50:57.000000000 +0100
@@ -41,3 +41,7 @@
 2010-02-28: Version 0.0.9
 
 - Added Lithuanian language translations (thanks to Valdemaras Pipiras).
+
+2011-02-20: Version 0.1.0
+
+- Fixed reallocating memory (reported by Paul Menzel).
diff -ruN vdr-1.7.16/PLUGINS/src/pictures/Makefile vdr-1.7.17/PLUGINS/src/pictures/Makefile
--- vdr-1.7.16/PLUGINS/src/pictures/Makefile	2010-02-06 15:50:03.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/pictures/Makefile	2011-02-27 11:05:02.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.2 2010/02/06 14:50:03 kls Exp $
+# $Id: Makefile 2.6 2011/02/27 10:05:02 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -18,7 +18,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
@@ -83,7 +83,7 @@
 	msgfmt -c -o $@ $<
 
 $(I18Npot): $(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@tvdr.de>' -o $@ $^
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=VDR --package-version=$(VDRVERSION) --msgid-bugs-address='<vdr-bugs@tvdr.de>' -o $@ $^
 
 %.po: $(I18Npot)
 	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
@@ -99,10 +99,10 @@
 ### Targets:
 
 libvdr-$(PLUGIN).so: $(OBJS)
-	$(CXX) $(CXXFLAGS) -shared $(OBJS) -o $@
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(OBJS) -o $@
 	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
 
-dist: clean
+dist: $(I18Npo) clean
 	@-rm -rf $(TMPDIR)/$(ARCHIVE)
 	@mkdir $(TMPDIR)/$(ARCHIVE)
 	@cp -a * $(TMPDIR)/$(ARCHIVE)
diff -ruN vdr-1.7.16/PLUGINS/src/pictures/pictures.c vdr-1.7.17/PLUGINS/src/pictures/pictures.c
--- vdr-1.7.16/PLUGINS/src/pictures/pictures.c	2010-02-28 13:49:55.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/pictures/pictures.c	2011-02-20 17:50:01.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: pictures.c 2.2 2010/02/28 12:49:55 kls Exp $
+ * $Id: pictures.c 2.3 2011/02/20 16:50:01 kls Exp $
  */
 
 #include <getopt.h>
@@ -11,7 +11,7 @@
 #include "menu.h"
 #include "player.h"
 
-static const char *VERSION       = "0.0.9";
+static const char *VERSION       = "0.1.0";
 static const char *DESCRIPTION   = trNOOP("A simple picture viewer");
 static const char *MAINMENUENTRY = trNOOP("Pictures");
 
diff -ruN vdr-1.7.16/PLUGINS/src/pictures/player.c vdr-1.7.17/PLUGINS/src/pictures/player.c
--- vdr-1.7.16/PLUGINS/src/pictures/player.c	2008-02-09 13:13:10.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/pictures/player.c	2011-02-20 18:15:25.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: player.c 2.0 2008/02/09 12:13:10 kls Exp $
+ * $Id: player.c 2.1 2011/02/20 17:15:25 kls Exp $
  */
 
 #include "player.h"
@@ -66,8 +66,15 @@
          length = read(f, buffer, size);
          if (length > 0) {
             if (length >= size) {
-               size = size * 3 / 2;
-               buffer = (uchar *)realloc(buffer, size);
+               int NewSize = size * 3 / 2;
+               if (uchar *NewBuffer = (uchar *)realloc(buffer, NewSize)) {
+                  buffer = NewBuffer;
+                  size = NewSize;
+                  }
+               else {
+                  LOG_ERROR_STR("out of memory");
+                  break;
+                  }
                lseek(f, 0, SEEK_SET);
                continue;
                }
diff -ruN vdr-1.7.16/PLUGINS/src/servicedemo/Makefile vdr-1.7.17/PLUGINS/src/servicedemo/Makefile
--- vdr-1.7.16/PLUGINS/src/servicedemo/Makefile	2010-02-06 15:50:03.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/servicedemo/Makefile	2011-02-27 11:05:04.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.1 2010/02/06 14:50:03 kls Exp $
+# $Id: Makefile 2.3 2011/02/27 10:05:04 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -18,7 +18,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
@@ -74,11 +74,11 @@
 ### Targets:
 
 libvdr-$(PLUGIN1).so: $(PLUGIN1).o
-	$(CXX) $(CXXFLAGS) -shared $(PLUGIN1).o -o $@
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(PLUGIN1).o -o $@
 	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
 
 libvdr-$(PLUGIN2).so: $(PLUGIN2).o
-	$(CXX) $(CXXFLAGS) -shared $(PLUGIN2).o -o $@
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(PLUGIN2).o -o $@
 	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
 
 dist: clean
diff -ruN vdr-1.7.16/PLUGINS/src/skincurses/Makefile vdr-1.7.17/PLUGINS/src/skincurses/Makefile
--- vdr-1.7.16/PLUGINS/src/skincurses/Makefile	2010-02-06 15:50:03.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/skincurses/Makefile	2011-02-27 11:05:05.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.2 2010/02/06 14:50:03 kls Exp $
+# $Id: Makefile 2.6 2011/02/27 10:05:05 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -18,7 +18,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
@@ -83,7 +83,7 @@
 	msgfmt -c -o $@ $<
 
 $(I18Npot): $(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@tvdr.de>' -o $@ $^
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --package-name=VDR --package-version=$(VDRVERSION) --msgid-bugs-address='<vdr-bugs@tvdr.de>' -o $@ $^
 
 %.po: $(I18Npot)
 	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
@@ -99,10 +99,10 @@
 ### Targets:
 
 libvdr-$(PLUGIN).so: $(OBJS)
-	$(CXX) $(CXXFLAGS) -shared $(OBJS) -lncursesw -o $@
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(OBJS) -lncursesw -o $@
 	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
 
-dist: clean
+dist: $(I18Npo) clean
 	@-rm -rf $(TMPDIR)/$(ARCHIVE)
 	@mkdir $(TMPDIR)/$(ARCHIVE)
 	@cp -a * $(TMPDIR)/$(ARCHIVE)
diff -ruN vdr-1.7.16/PLUGINS/src/skincurses/skincurses.c vdr-1.7.17/PLUGINS/src/skincurses/skincurses.c
--- vdr-1.7.16/PLUGINS/src/skincurses/skincurses.c	2010-02-28 13:50:13.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/skincurses/skincurses.c	2011-01-04 09:52:03.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: skincurses.c 2.4 2010/02/28 12:50:13 kls Exp $
+ * $Id: skincurses.c 2.5 2011/01/04 08:52:03 kls Exp $
  */
 
 #include <ncurses.h>
@@ -23,6 +23,7 @@
   virtual int Width(const char *s) const { return s ? Utf8StrLen(s) : 0; }
   virtual int Height(void) const { return 1; }
   virtual void DrawText(cBitmap *Bitmap, int x, int y, const char *s, tColor ColorFg, tColor ColorBg, int Width) const {}
+  virtual void DrawText(cPixmap *Pixmap, int x, int y, const char *s, tColor ColorFg, tColor ColorBg, int Width) const {}
   };
 
 static const cCursesFont Font;
diff -ruN vdr-1.7.16/PLUGINS/src/status/Makefile vdr-1.7.17/PLUGINS/src/status/Makefile
--- vdr-1.7.16/PLUGINS/src/status/Makefile	2010-02-06 15:50:03.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/status/Makefile	2011-02-27 11:05:08.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.1 2010/02/06 14:50:03 kls Exp $
+# $Id: Makefile 2.3 2011/02/27 10:05:08 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -16,7 +16,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
@@ -72,7 +72,7 @@
 ### Targets:
 
 libvdr-$(PLUGIN).so: $(OBJS)
-	$(CXX) $(CXXFLAGS) -shared $(OBJS) -o $@
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(OBJS) -o $@
 	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
 
 dist: clean
diff -ruN vdr-1.7.16/PLUGINS/src/svdrpdemo/Makefile vdr-1.7.17/PLUGINS/src/svdrpdemo/Makefile
--- vdr-1.7.16/PLUGINS/src/svdrpdemo/Makefile	2010-02-06 15:50:03.000000000 +0100
+++ vdr-1.7.17/PLUGINS/src/svdrpdemo/Makefile	2011-02-27 11:05:10.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.1 2010/02/06 14:50:03 kls Exp $
+# $Id: Makefile 2.3 2011/02/27 10:05:10 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -16,7 +16,7 @@
 ### The C++ compiler and options:
 
 CXX      ?= g++
-CXXFLAGS ?= -g -O2 -Wall -Woverloaded-virtual -Wno-parentheses
+CXXFLAGS ?= -g -O3 -Wall -Woverloaded-virtual -Wno-parentheses
 
 ### The directory environment:
 
@@ -72,7 +72,7 @@
 ### Targets:
 
 libvdr-$(PLUGIN).so: $(OBJS)
-	$(CXX) $(CXXFLAGS) -shared $(OBJS) -o $@
+	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $(OBJS) -o $@
 	@cp --remove-destination $@ $(LIBDIR)/$@.$(APIVERSION)
 
 dist: clean
diff -ruN vdr-1.7.16/channels.c vdr-1.7.17/channels.c
--- vdr-1.7.16/channels.c	2010-06-05 15:33:57.000000000 +0200
+++ vdr-1.7.17/channels.c	2010-11-07 13:24:59.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 2.16 2010/06/05 13:33:57 kls Exp $
+ * $Id: channels.c 2.17 2010/11/07 12:24:59 kls Exp $
  */
 
 #include "channels.h"
@@ -262,12 +262,14 @@
 {
   int result = 0;
   for (int i = 0; a[i] || b[i]; i++) {
-      if (a[i] && na && nb && strcmp(na[i], nb[i]) != 0)
+      if (!a[i] || !b[i]) {
+         result |= VALDIFF;
+         break;
+         }
+      if (na && nb && strcmp(na[i], nb[i]) != 0)
          result |= STRDIFF;
       if (a[i] != b[i])
          result |= VALDIFF;
-      if (!a[i] || !b[i])
-         break;
       }
   return result;
 }
diff -ruN vdr-1.7.16/config.h vdr-1.7.17/config.h
--- vdr-1.7.16/config.h	2010-09-12 13:31:21.000000000 +0200
+++ vdr-1.7.17/config.h	2010-10-24 13:22:35.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.28 2010/09/12 11:31:21 kls Exp $
+ * $Id: config.h 2.29 2010/10/24 11:22:35 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.16"
-#define VDRVERSNUM   10716  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.17"
+#define VDRVERSNUM   10717  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.16"
-#define APIVERSNUM   10716  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.17"
+#define APIVERSNUM   10717  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.7.16/cutter.c vdr-1.7.17/cutter.c
--- vdr-1.7.16/cutter.c	2010-08-29 15:35:18.000000000 +0200
+++ vdr-1.7.17/cutter.c	2011-03-06 15:54:33.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 2.5 2010/08/29 13:35:18 kls Exp $
+ * $Id: cutter.c 2.6 2011/03/06 14:54:33 kls Exp $
  */
 
 #include "cutter.h"
@@ -68,6 +68,8 @@
 {
   cMark *Mark = fromMarks.First();
   if (Mark) {
+     SetPriority(19);
+     SetIOPriority(7);
      fromFile = fromFileName->Open();
      toFile = toFileName->Open();
      if (!fromFile || !toFile)
diff -ruN vdr-1.7.16/device.c vdr-1.7.17/device.c
--- vdr-1.7.16/device.c	2010-06-03 15:35:02.000000000 +0200
+++ vdr-1.7.17/device.c	2011-02-25 16:12:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.37 2010/06/03 13:35:02 kls Exp $
+ * $Id: device.c 2.38 2011/02/25 15:12:03 kls Exp $
  */
 
 #include "device.h"
@@ -1087,11 +1087,17 @@
                  int l;
                  while (const uchar *p = TsToPes.GetPes(l)) {
                        int Offset = Size;
-                       Size += l;
-                       buf = (uchar *)realloc(buf, Size);
-                       if (!buf)
+                       int NewSize = Size + l;
+                       if (uchar *NewBuffer = (uchar *)realloc(buf, NewSize)) {
+                          Size = NewSize;
+                          buf = NewBuffer;
+                          memcpy(buf + Offset, p, l);
+                          }
+                       else {
+                          LOG_ERROR_STR("out of memory");
+                          free(buf);
                           return;
-                       memcpy(buf + Offset, p, l);
+                          }
                        }
                  TsToPes.Reset();
                  }
@@ -1103,11 +1109,17 @@
      int l;
      while (const uchar *p = TsToPes.GetPes(l)) {
            int Offset = Size;
-           Size += l;
-           buf = (uchar *)realloc(buf, Size);
-           if (!buf)
+           int NewSize = Size + l;
+           if (uchar *NewBuffer = (uchar *)realloc(buf, NewSize)) {
+              Size = NewSize;
+              buf = NewBuffer;
+              memcpy(buf + Offset, p, l);
+              }
+           else {
+              esyslog("ERROR: out of memory");
+              free(buf);
               return;
-           memcpy(buf + Offset, p, l);
+              }
            }
      StillPicture(buf, Size);
      free(buf);
